/*
 * soelim -- expand .so and .nx requests in troff input
 *	forsyth@plan9.cs.york.ac.uk
 */
#include <u.h>
#include <libc.h>
#include <stdio.h>

#define	MAXLINE 2000

char	*progname;
static	void	soelim(char *name);
static	void	process(FILE *fp);

void
main(int argc, char **argv)
{
	if ((progname = strrchr(argv[0], '/')) == 0)
		progname = argv[0];
	else
		progname++;
	if (argc <= 1) {
		process(stdin);
		exits(0);
	}
	while (--argc > 0)
		soelim((++argv)[0]);
	exits(0);
}

static void
soelim(char *name)
{
	FILE *fp;

	fp = fopen(name, "r");
	if(fp == 0) {
		fprint(2, "soelim: cannot open %s: %r\n", name);
		exits("open");
	}
	process(fp);
	fclose(fp);
}

static void
process(FILE *fp)
{
	char *rp, *np, *cp, *lp;
	char line[MAXLINE];

	lp = line;
	while (fgets(line, sizeof line, fp) != NULL) {
		if (*lp == '.') {
			for (rp = lp+1; *rp == ' ' || *rp == '\t'; rp++)
				;
			if (strncmp(rp, "so", 2) == 0 || strncmp(rp, "nx", 2) ==  0) {
				for (np = rp+2; *np == ' ' || *np == '\t'; np++)
					;
				if (*np != '\n') {
					if ((cp = strchr(np, '\n')) != NULL)
						*cp = '\0';
					if (*rp == 'n') {
						if(freopen(np, "r", fp) == 0) {
							fprint(2, "soelim: can't open %s: %r\n", np);
							exits("open");
						}
					} else
						soelim(np);
					continue;
				}
			}
		}
		fputs(lp, stdout);
	}
}
